/*MyPhotoIndex Free Photo Organizer <www.myphotoindex.com>
  Copyright (C) <2006-2009>  <Asaf Yarkoni asaf@yarkoni.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using MyPhotoIndex.Interfaces.Tagging;

namespace MyPhotoIndex.Controls
{
    public class TagTreeSorter : IComparer<TreeNode>, IComparer
    {
        #region IComparer<TreeNode> Members

        public int Compare(TreeNode x, TreeNode y)
        {
            if (x.Parent != null)
            {
                if (x.Tag == null ||
                    y.Tag == null)
                {
                    return 0;
                }
                // return string.Compare(x.Text, y.Text);
                int offsetX = ((IImageTag)x.Tag).Offset;
                int offsetY = ((IImageTag)y.Tag).Offset;

                if (offsetX > offsetY)
                {
                    return 1;
                }
                else
                    if (offsetX < offsetY)
                    {
                        return -1;
                    }
            }
            else
            {
                return string.Compare(x.Text, y.Text);
            }

            return 0;
        }

        #endregion

        #region IComparer Members

        public int Compare(object x, object y)
        {
            return Compare((TreeNode)x, (TreeNode)y);
        }

        #endregion
    }
}
