using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using MyPhotoIndex.Interfaces.Imaging;

namespace MyPhotoIndex.Controls
{
    public class CategoryRenderer
    {
        public virtual void Render(Graphics graphics, Rectangle drawingRect, IImageData imageData)
        {
            DrawBackGround(graphics, drawingRect);
            DrawFrame(graphics, drawingRect);
        }

        protected virtual void DrawBackGround(Graphics graphics, Rectangle drawingRect)
        {
            graphics.FillRectangle(Brushes.White, drawingRect);
        }

        protected virtual void DrawFrame(Graphics graphics, Rectangle drawingRect)
        {
            using (Pen catFramePen = new Pen(Color.FromArgb(187, 194, 204)))
            {
                graphics.DrawRectangle(catFramePen, drawingRect);
            }
        }
    }
}
