/*MyPhotoIndex Free Photo Organizer <www.myphotoindex.com>
  Copyright (C) <2006-2009>  <Asaf Yarkoni asaf@yarkoni.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;

namespace MyPhotoIndex.Controls
{
    public class ThumbnailMouseEventArgs : EventArgs
    {
        private int             m_imageId;
        private MouseButtons    m_mouseButton;
        private Keys            m_modifiers;
        private int             m_x;
        private int             m_Y;
        private ThumbnailIcon   m_thumbnailIcon;
        private Rectangle       m_frameRect;

        public ThumbnailMouseEventArgs(int imageId, MouseButtons mouseButton, Keys modifiers, int x, int y, ThumbnailIcon thumbnailIcon, Rectangle frameRect)
        {
            m_imageId = imageId;
            m_mouseButton = mouseButton;
            m_modifiers = modifiers;
            m_x = x;
            m_Y = y;
            m_thumbnailIcon = thumbnailIcon;
            m_frameRect = frameRect;
        }

        public MouseButtons MouseButton
        {
            get { return m_mouseButton; }
            set { m_mouseButton = value; }
        }

        public int ImageId
        {
            get { return m_imageId; }
            set { m_imageId = value; }
        }

        public Keys Modifiers
        {
            get { return m_modifiers; }
            set { m_modifiers = value; }
        }

        public int X
        {
            get { return m_x; }
            set { m_x = value; }
        }

        public int Y
        {
            get { return m_Y; }
            set { m_Y = value; }
        }

        public ThumbnailIcon ThumbnailIcon
        {
            get { return m_thumbnailIcon; }
            set { m_thumbnailIcon = value; }
        }

        public Rectangle FrameRect
        {
            get { return m_frameRect; }
            set { m_frameRect = value; }
        }   
    }
}
