/*MyPhotoIndex Free Photo Organizer <www.myphotoindex.com>
  Copyright (C) <2006-2009>  <Asaf Yarkoni asaf@yarkoni.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
using System;
using System.Collections.Generic;
using System.Text;
using System.Data.OleDb;
using MyPhotoIndex.DataAccess;
using System.Data;
using System.Data.SqlClient;
using System.Threading;
using MyPhotoIndex.Interfaces;
using MyPhotoIndex.Plugins.DataProviders;

namespace MyPhotoIndex.DataAccess
{
    public class DataAccessProvider
    {
        private static IDataAccessProvider      m_instance;
        private static Type                     m_defaultDataProvider = typeof(MSAccessDataProvider);

        private DataAccessProvider()
        {
           
        }

        public static Type DefaultDataProvider
        {
            get { return m_defaultDataProvider; }
            set { m_defaultDataProvider = value; }
        }

        public static IDataAccessProvider Instance
        {
            get
            {
                if (m_instance == null)
                {
                    lock (typeof(DataAccessProvider))
                    {
                        if (m_instance == null)
                        {
                            m_instance = (IDataAccessProvider)Activator.CreateInstance(m_defaultDataProvider);
                        }
                    }
                }

                return m_instance;
            }
        }
    }
}
