/*MyPhotoIndex Free Photo Organizer <www.myphotoindex.com>
  Copyright (C) <2006-2009>  <Asaf Yarkoni asaf@yarkoni.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using MyPhotoIndex.Interfaces;
using MyPhotoIndex.Interfaces.Imaging;

namespace MyPhotoIndex.ImageBank
{
    internal class ImageLoadRequest
    {
        private IImageData          m_imageData;
        private Size                m_requestedSize;
        private ImageLoadDelegate   m_imageLoadDelegate;
        private object              m_tag;

        public ImageLoadRequest(IImageData imageData, Size requestedSize, ImageLoadDelegate imageLoadDelegate, object tag)
        {
            m_imageData = imageData;
            m_requestedSize = requestedSize;
            m_imageLoadDelegate = imageLoadDelegate;
            m_tag = tag;
        }

        public IImageData ImageData
        {
            get { return m_imageData; }
        }

        public Size RequestedSize
        {
            get { return m_requestedSize; }
        }

        public ImageLoadDelegate ImageLoadDelegate
        {
            get { return m_imageLoadDelegate; }
        }

        public object Tag
        {
            get { return m_tag; }
        }
    }
}
