/*MyPhotoIndex Free Photo Organizer <www.myphotoindex.com>
  Copyright (C) <2006-2009>  <Asaf Yarkoni asaf@yarkoni.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
using System;
using System.Collections.Generic;
using System.Text;

namespace MyPhotoIndex.ImageBank.Query
{
    public class ImageDateTakenQueryParameter : QueryParameter<DateTime>
    {
        public ImageDateTakenQueryParameter(DateTime dateTaken, QueryParameterOperation operation)
        {
            base.ParameterData = dateTaken;
            base.PropertyPath = "DateTaken";
            base.Operation = operation;
        }

        public override int GetHashCode()
        {
            return base.GetHashCode();
        }

        public override bool Equals(Object value)
        {
            DateTime dValue = (DateTime)value;
            DateTime compareValue = new DateTime(dValue.Year, dValue.Month, dValue.Day);

            return (((DateTime)base.ParameterData).CompareTo(compareValue) == 0);
        }

        public override bool GreaterThen(Object value)
        {
            return (((DateTime)base.ParameterData).CompareTo(value) < 0);
        }

        public override bool LessThen(Object value)
        {
            return (((DateTime)base.ParameterData).CompareTo(value) > 0);
        }

        public override bool LessThenEquals(Object value)
        {
            DateTime dValue = (DateTime)value;
            DateTime compareValue = new DateTime(dValue.Year, dValue.Month, dValue.Day);

            return (((DateTime)base.ParameterData).CompareTo(compareValue) >= 0);
        }
    }
}
