/*MyPhotoIndex Free Photo Organizer <www.myphotoindex.com>
  Copyright (C) <2006-2009>  <Asaf Yarkoni asaf@yarkoni.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
using System;
using System.Collections.Generic;
using System.Text;
using MyPhotoIndex.Interfaces;
using MyPhotoIndex.Interfaces.Imaging;

namespace MyPhotoIndex.ImageBank
{
    public class QueryHelper : IImageCollection
    {
        private Dictionary<int, IImageData> m_imageList;

        public QueryHelper(Dictionary<int, IImageData> imageList)
        {
            m_imageList = imageList;
        }

        #region IImageCollection Members

        public event EventHandler<EventArgs> ImageCollectionLoadedEvent;

        public void Remove(int imageId)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public void Remove(int imageId, bool deleteFromMedia)
        {
            throw new Exception("The method or operation is not implemented.");
        }

        public IImageData this[int imageId]
        {
            get { return m_imageList[imageId]; }
        }

        public int Count
        {
            get { return m_imageList.Count; }
        }

        public IImageData[] ToArray()
        {
            List<IImageData> list = new List<IImageData>(m_imageList.Values);
            return list.ToArray();
        }

        #endregion

        #region IEnumerable<IImageData> Members

        public IEnumerator<IImageData> GetEnumerator()
        {
            return m_imageList.Values.GetEnumerator();
        }

        #endregion

        #region IEnumerable Members

        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return GetEnumerator();
        }

        #endregion

        #region IDisposable Members

        public void Dispose()
        {
            throw new Exception("The method or operation is not implemented.");
        }

        #endregion
    }
}
