/*MyPhotoIndex Free Photo Organizer <www.myphotoindex.com>
  Copyright (C) <2006-2009>  <Asaf Yarkoni asaf@yarkoni.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
using System;
using System.Collections.Generic;
using System.Text;
using MyPhotoIndex.DataAccess;
using System.IO;
using System.Drawing;
using System.Drawing.Imaging;
using System.Threading;
using MyPhotoIndex.Utilities;
using MyPhotoIndex.Plugins.ImageFormatProviders;

namespace MyPhotoIndex.Importer
{
    public class FileImageDataImporter : ImageDataImporter
    {
        public FileImageDataImporter(string importBatch):
            base(importBatch)
        {
        }

        public void ImportFromDirectory(string path, Size thumbnailSize)
        {
            string[] searchPatterns = ImageFormatProviders.Default.ImporterFilterFormat.Split(new char[] { ';' });
            foreach (string searchPattern in searchPatterns)
            {
                if (string.IsNullOrEmpty(searchPattern))
                {
                    continue;
                }

                string[] fileList = Directory.GetFiles(path, searchPattern, SearchOption.AllDirectories);

                base.FileList.AddRange(fileList);
            }

            Import(thumbnailSize);
        }

        public void ImportFromFileList(string[] imageFiles, Size thumbnailSize)
        {
            base.FileList.AddRange(imageFiles);
            Import(thumbnailSize);
        }
    }
}
