/*MyPhotoIndex Free Photo Organizer <www.myphotoindex.com>
  Copyright (C) <2006-2009>  <Asaf Yarkoni asaf@yarkoni.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
using System;
using System.Collections.Generic;
using System.Text;
using MyPhotoIndex.Interfaces;
using System.Drawing.Printing;
using MyPhotoIndex.Plugins.Printing;
using System.Collections.ObjectModel;
using MyPhotoIndex.Interfaces.Plugins;
using MyPhotoIndex.Interfaces.Imaging;

namespace MyPhotoIndex.Plugins
{
    public class PrintPluginBase : IPrintPlugin
    {
        private bool m_landscape;
        protected IApplicationContext m_applicationContext;

        public PrintPluginBase()
        {
        }

        #region IPlugin Members

        public virtual bool Load(IApplicationContext applicationContext)
        {
            m_applicationContext = applicationContext;
            return false;
        }

        public string Name
        {
            get
            {
                return ToString();
            }
        }

        public void Unload()
        {

        }

        #endregion

        #region IPrintPlugin Members


        public virtual bool PrintLandscape
        {
            get
            {
                return m_landscape;
            }
            set
            {
                m_landscape = value;
            }
        }

        #endregion

        #region IPrintPlugin Members

        public virtual PrintDocument GetPrintDocument(ReadOnlyCollection<IImageData> imageDataLaist)
        {
            throw new NotImplementedException();
        }

        #endregion

        #region IPlugin Members


        public string Description
        {
            get { throw new Exception("The method or operation is not implemented."); }
        }

        #endregion
    }



}
