﻿/*MyPhotoIndex Free Photo Organizer <www.myphotoindex.com>
  Copyright (C) <2006-2009>  <Asaf Yarkoni asaf@yarkoni.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.
  
  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
using System;
using System.Collections.Generic;
using System.Text;
using MyPhotoIndex.Interfaces.Plugins;
using System.Collections.ObjectModel;
using MyPhotoIndex.Interfaces;
using MyPhotoIndex.Controls;
using MyPhotoIndex.Plugins.WebHost.Properties;

namespace MyPhotoIndex.Plugins.WebHost
{
    public class WebHostPlugin : IUtilityPlugin
    {
        private IApplicationContext m_applicationContext;
        static SettingsForm ms_settingsForm = null;
        private HttpHost m_host;

        #region IUtilityPlugin Members

        public void ImageSelectionChanged(ReadOnlyCollection<int> selectedImages, SelectedImageInfo lastSelected)
        {
        }

        public void RegisterMenues(List<IPluginMenuInfo> pluginMenuInfoList)
        {
            PluginMenuInfo menuInfo = new PluginMenuInfo();
            menuInfo.MenuItemId = Guid.NewGuid();
            menuInfo.Name = Resources.menu1;
            menuInfo.Icon = Resources.server_client;
            menuInfo.MenuItemClick += new EventHandler<PluginMenuClickEventArgs>(menuInfo_MenuItemClick);
            menuInfo.MenuItemQueryState += new EventHandler<PluginMenuStateQueryEventArgs>(menuInfo_MenuItemQueryState);

            pluginMenuInfoList.Add(menuInfo);
        }

        void menuInfo_MenuItemQueryState(object sender, PluginMenuStateQueryEventArgs e)
        {
            e.Enabled = ms_settingsForm == null || (ms_settingsForm.Visible == false);
        }

        void menuInfo_MenuItemClick(object sender, PluginMenuClickEventArgs e)
        {
            if (ms_settingsForm == null)
             {
                 ms_settingsForm = new SettingsForm(m_applicationContext, ref m_host);
             }

            ms_settingsForm.Show(ApplicationAlert.DefaultOwner);
        }

        #endregion

        #region IPlugin Members

        public string Description
        {
            get { return "My photo Index Web Interface"; }
        }

        public bool Load(IApplicationContext applicationContext)
        {
            m_applicationContext = applicationContext;
            WebHostPluginSettings.SettingsManager = m_applicationContext.SettingsManager; 

            int httpListeningPort = WebHostPluginSettings.Default.Port;

            m_host = new HttpHost(httpListeningPort);
            m_host.UseAuthentication = WebHostPluginSettings.Default.UseAuthentication;
            if (WebHostPluginSettings.Default.UseWebInterface == true)
            {
                m_host.Start();
            }

            return true;
        }

        public string Name
        {
            get { return "Web Interface"; }
        }

        public void Unload()
        {
            if (ms_settingsForm != null)
            {
                ms_settingsForm.CloseForm();
            }

            m_host.Stop();
        }

        #endregion
    }
}
