/*MyPhotoIndex Free Photo Organizer <www.myphotoindex.com>
  Copyright (C) <2006-2009>  <Asaf Yarkoni asaf@yarkoni.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
using System;
using System.Collections.Generic;
using System.Text;
using MyPhotoIndex.Interfaces;
using System.Globalization;
using MyPhotoIndex.Interfaces.Tagging;
using MyPhotoIndex.Interfaces.Imaging;

namespace MyPhotoIndex
{
    public class ApplicationContext : Singleton<ApplicationContext>, IApplicationContext
    {
        ISettingsManager m_settingsmanager;
        IProcessProgress m_processProgress;
        IImageTagCollection m_tagsCollection;
        IImageCollection m_imageCollection;
        IImageCategoryCollection m_imageCategoryCollection;

        #region IApplicationContext Members

        public ISettingsManager SettingsManager
        {
            get { return m_settingsmanager; }
            set { m_settingsmanager = value; }
        }

        public IProcessProgress ProcessProgress
        {
            get { return m_processProgress; }
            set { m_processProgress = value; }
        }

        public IImageTagCollection ImageTagCollection
        {
            get { return m_tagsCollection; }
            set { m_tagsCollection = value; }
        }

        public IImageCollection ImageCollection
        {
            get { return m_imageCollection; }
            set { m_imageCollection = value; }
        }

        public IImageCategoryCollection ImageCategoryCollection
        {
            get { return m_imageCategoryCollection; }
            set { m_imageCategoryCollection = value; }
        }

        #endregion
    }
}
