/*MyPhotoIndex Free Photo Organizer <www.myphotoindex.com>
  Copyright (C) <2006-2009>  <Asaf Yarkoni asaf@yarkoni.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MyPhotoIndex.Controls;
using System.IO;
using MyPhotoIndex.Utilities;

namespace MyPhotoIndex
{
    public partial class EditSourceLabelForm : FormTemplate
    {
        public EditSourceLabelForm()
        {
            InitializeComponent();

            DriveInfo[] drivesInfo = DriveInfo.GetDrives();
            foreach (DriveInfo driveInfo in drivesInfo)
            {
                try
                {
                    if (driveInfo.IsReady == true)
                    {
                        drivesListComboBox.Items.Add(driveInfo.Name + " - " + driveInfo.VolumeLabel);
                    }
                }
                catch (Exception ex)
                {
                    Logger.Log(ex);
                }
            }

            drivesListComboBox.SelectedIndexChanged += new EventHandler(drivesListComboBox_SelectedIndexChanged);
        }

        void drivesListComboBox_SelectedIndexChanged(object sender, EventArgs e)
        {
            CommentTextBox.Text = (string)drivesListComboBox.SelectedItem;
        }

        public String Label
        {
            get
            {
                return CommentTextBox.Text;
            }
            set
            {
                CommentTextBox.Text = value;
            }
        }
    }
}