﻿/*MyPhotoIndex Free Photo Organizer <www.myphotoindex.com>
  Copyright (C) <2006-2009>  <Asaf Yarkoni asaf@yarkoni.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
using System;
using System.Collections.Generic;
using System.Text;
using MyPhotoIndex.Interfaces.Imaging;
using System.IO;
using MyPhotoIndex.Utilities;

namespace MyPhotoIndex
{
    public class ImageOperations
    {
        public static void UpdateThumbnail(IImageData imageData, object state)
        {
            imageData.Update(true, true);
            imageData.InvokeChangedEvent();
        }

        public static void UpdateSourceLabel(IImageData imageData, string label)
        {
            imageData.SourceLabel = label;
            imageData.Update(false, false);
            imageData.InvokeChangedEvent();
        }

        public static void UpdateComments(IImageData imageData, string comment)
        {
            imageData.Comment = comment;
            imageData.Update(true, false);
        }

        public static void MoveImage(IImageData imageData, string newLocation)
        {
            string fileName = Path.GetFileName(imageData.FileName);
            string newImageLocation = Path.Combine(newLocation, fileName);

            if (File.Exists(fileName) == true)
            {//maybe the file has moved already so just updaqte the location...
                File.Move(imageData.FileName, newImageLocation);
            }

            imageData.FileName = newImageLocation;
            imageData.Update(false, false);
        }
    }
}
