﻿/*MyPhotoIndex Free Photo Organizer <www.myphotoindex.com>
  Copyright (C) <2006-2009>  <Asaf Yarkoni asaf@yarkoni.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
using System;
using System.Collections.Generic;
using System.Text;
using MyPhotoIndex.Settings;
using MyPhotoIndex.Controls;
using System.Windows.Forms;

namespace MyPhotoIndex
{
    public partial class Main
    {
        private void RegisterThumbnailInfoTextContextMenuEvents()
        {
            dateDigitizedToolStripMenuItem.Click += new EventHandler(dateDigitizedToolStripMenuItem_Click);
            dateTakenToolStripMenuItem.Click += new EventHandler(dateTakenToolStripMenuItem_Click);
            fileNameToolStripMenuItem.Click += new EventHandler(fileNameToolStripMenuItem_Click);

            dateDigitizedToolStripMenuItem.Visible = false;
        }

        private void PopupThumbnailInfoTextContextMenu(int x, int y)
        {
            foreach (ToolStripMenuItem menuItem in dateTextContextMenu.Items)
            {
                menuItem.Checked = false;
            }

            switch (ApplicationSettings.Default.ThumbnailTextInfoDisplayType)
            {
                case ThumbnailTextInfo.DateTaken:
                    dateTakenToolStripMenuItem.Checked = true;
                    break;
                case ThumbnailTextInfo.DateDigitized:
                    dateDigitizedToolStripMenuItem.Checked = true;
                    break;
                case ThumbnailTextInfo.FileName:
                    fileNameToolStripMenuItem.Checked = true;
                    break;
                default:
                    break;
            }

            dateTextContextMenu.Show(photoThumbViewer1, x, y);
        }

        private void SetThumbnailInfoText(ThumbnailTextInfo thumbnailTextInfo)
        {
            photoThumbViewer1.ThumbnailTextInfoDisplayType = thumbnailTextInfo;
            ApplicationSettings.Default.ThumbnailTextInfoDisplayType = photoThumbViewer1.ThumbnailTextInfoDisplayType;
        }

        void fileNameToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SetThumbnailInfoText(ThumbnailTextInfo.FileName);
        }

        void dateTakenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SetThumbnailInfoText(ThumbnailTextInfo.DateTaken);
        }

        void dateDigitizedToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SetThumbnailInfoText(ThumbnailTextInfo.DateDigitized);
        }
    }
}
