/*MyPhotoIndex Free Photo Organizer <www.myphotoindex.com>
  Copyright (C) <2006-2009>  <Asaf Yarkoni asaf@yarkoni.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MyPhotoIndex.Controls;
using MyPhotoIndex.Settings;

namespace MyPhotoIndex
{
    public partial class SharePreferences : FormTemplate
    {
        public SharePreferences()
        {
            InitializeComponent();
            this.StartPosition = FormStartPosition.CenterParent;
        }

        private void SharePreferences_Load(object sender, EventArgs e)
        {
            
            LoadImageSizeCombo();
        }

        private void LoadImageSizeCombo()
        {
            imageSizeCombobox.Items.Clear();

            imageSizeCombobox.Items.Add(new ImageResize(new Size(1280, 960), Resources.Resources.ImageSize_VeryBig));
            imageSizeCombobox.Items.Add(new ImageResize(new Size(1024, 768), Resources.Resources.ImageSize_Big));
            imageSizeCombobox.Items.Add(new ImageResize(new Size(800, 600), Resources.Resources.ImageSize_Medium));
            imageSizeCombobox.Items.Add(new ImageResize(new Size(640, 480), Resources.Resources.ImageSize_Small));
            imageSizeCombobox.Items.Add(new ImageResize(Size.Empty, Resources.Resources.ImageSize_Original));

            Size defaultSize = ApplicationSettings.Default.DefaultMailImageSize;
            //if (defaultSize == default(Size))
            //{
            //    imageSizeCombobox.SelectedIndex = 0;
            //}
          //  else
            {
                foreach (ImageResize imageSize in imageSizeCombobox.Items)
                {
                    if (imageSize.Size == defaultSize)
                    {
                        imageSizeCombobox.SelectedItem = imageSize;
                        break;
                    }
                }
            }
        }

        protected override void OkButton_Click(object sender, EventArgs e)
        {
            Size imageSize = ((ImageResize)imageSizeCombobox.SelectedItem).Size;
            ApplicationSettings.Default.DefaultMailImageSize = imageSize;
            ApplicationSettings.Default.ShowShareSettingsForm = !DontAskMeAgainCheckBox.Checked;
            DynamicConfiguration.Default.Save();

            base.OkButton_Click(sender, e);
        }
    }
}