/*MyPhotoIndex Free Photo Organizer <www.myphotoindex.com>
  Copyright (C) <2006-2009>  <Asaf Yarkoni asaf@yarkoni.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;
using MyPhotoIndex.Interfaces;
using System.Windows.Forms;
using System.Threading;

namespace MyPhotoIndex
{
    [Serializable]
    public class    ProcessProgress : IProcessProgress
    {
        #region IProcessProgress Members

        public int ProcessId
        {
            get
            {
                int tid = Thread.CurrentThread.ManagedThreadId;
                return ActiveProcesses.Instance.Get(tid).ProcessId;
            }
            set{}
        }

        public int Maximum
        {
            get
            {
                int tid = Thread.CurrentThread.ManagedThreadId;
                return ActiveProcesses.Instance.Get(tid).Maximum;
            }
            set
            {
                int tid = Thread.CurrentThread.ManagedThreadId;
                ActiveProcesses.Instance.Get(tid).Maximum = value;
            }
        }

        public int Value
        {
            get
            {
                int tid = Thread.CurrentThread.ManagedThreadId;
                return ActiveProcesses.Instance.Get(tid).Value;
            }
            set
            {
                int tid = Thread.CurrentThread.ManagedThreadId;
                ActiveProcesses.Instance.Get(tid).Value = value;
            }
        }

        public String ProcessDescription
        {
            get
            {
                int tid = Thread.CurrentThread.ManagedThreadId;
                return ActiveProcesses.Instance.Get(tid).ProcessDescription;
            }
            set
            {
                int tid = Thread.CurrentThread.ManagedThreadId;
                ActiveProcesses.Instance.Get(tid).ProcessDescription = value;
            }
        }

        public String ProcessMessage
        {
            get
            {
                int tid = Thread.CurrentThread.ManagedThreadId;
                return ActiveProcesses.Instance.Get(tid).ProcessMessage;
            }
            set
            {
                int tid = Thread.CurrentThread.ManagedThreadId;
                ActiveProcesses.Instance.Get(tid).ProcessMessage = value;
            }
        }

        public bool Running
        {
            get
            {
                int tid = Thread.CurrentThread.ManagedThreadId;
                return ActiveProcesses.Instance.Get(tid).Running;
            }
            set
            {
                int tid = Thread.CurrentThread.ManagedThreadId;
                ActiveProcesses.Instance.Get(tid).Running = value;
            }
        }

        public bool IsInfinite
        {
            get
            {
                int tid = Thread.CurrentThread.ManagedThreadId;
                return ActiveProcesses.Instance.Get(tid).IsInfinite;
            }
            set
            {
                int tid = Thread.CurrentThread.ManagedThreadId;
                ActiveProcesses.Instance.Get(tid).IsInfinite = value;
            }
        }

        public void Alert(ProcessAlertType alertType, string message, string description, string url)
        {
            int tid = Thread.CurrentThread.ManagedThreadId;
            ActiveProcesses.Instance.Get(tid).Alert(alertType, message, description, url);
        }

        #endregion
    }
}
