/*MyPhotoIndex Free Photo Organizer <www.myphotoindex.com>
  Copyright (C) <2006-2009>  <Asaf Yarkoni asaf@yarkoni.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MyPhotoIndex.Utilities;
using MyPhotoIndex.Controls;
using MyPhotoIndex.Importer.CameraImageAcquisition;

namespace MyPhotoIndex.Wizards.CameraImport
{
    public partial class CameraImageDownloadForm : FormTemplate
    {
        private ImagingDevice m_camera;

        public CameraImageDownloadForm(ImagingDevice camera)
        {
            InitializeComponent();
            this.StartPosition = FormStartPosition.CenterParent;

            m_camera = camera;
            m_camera.ThumbnailDownloadEvent += new EventHandler<ImagingDeviceImageTransferEventArgs>(m_camera_ThumbnailDownloadEvent);
        }

        void m_camera_ThumbnailDownloadEvent(object sender, ImagingDeviceImageTransferEventArgs e)
        {
           // label1.Text = e.Name;
            progressBar1.Maximum = e.TotalImages;
            progressBar1.Value = e.CurrentImage;
            Application.DoEvents();
        }

        private void CameraImageDownloadForm_Shown(object sender, EventArgs e)
        {
            m_camera.DownloadImages();
            this.Close();
        }
    }
}