/*MyPhotoIndex Free Photo Organizer <www.myphotoindex.com>
  Copyright (C) <2006-2009>  <Asaf Yarkoni asaf@yarkoni.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using MyPhotoIndex.Utilities;
using MyPhotoIndex.Controls;
using System.Globalization;

namespace MyPhotoIndex.Wizards.Import
{
    public partial class FilesSearchForm : FormTemplate
    {
        private FilesSearch m_filesSearch;

        public FilesSearchForm(FilesSearch filesSearch)
        {
            InitializeComponent();
            this.StartPosition = FormStartPosition.CenterParent;
            m_filesSearch = filesSearch;
            m_filesSearch.FilesSearchEvent += new EventHandler<FileSearchEventAgs>(m_filesSearch_FilesSearchEvent);
        }

        void m_filesSearch_FilesSearchEvent(object sender, FileSearchEventAgs e)
        {
            label1.Text = e.DirectoryName;
            label4.Text = e.FilesFound.ToString(CultureInfo.InvariantCulture);
            Application.DoEvents();

        }

        private void FilesSearchForm_Load(object sender, EventArgs e)
        {
            
        }

        private void FilesSearchForm_Shown(object sender, EventArgs e)
        {
            while (this.Opacity < 1)
            {
                Application.DoEvents();
            }

            m_filesSearch.Search();
            this.Close();
        }

        protected override void CancelButton_Click(object sender, EventArgs e)
        {
            m_filesSearch.Stop();
        }
    }
}