/*MyPhotoIndex Free Photo Organizer <www.myphotoindex.com>
  Copyright (C) <2006-2010>  <Asaf Yarkoni asaf@yarkoni.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
using System;
using System.Collections.Generic;
using System.Text;
using MyPhotoIndex.Interfaces;
using System.ComponentModel;

namespace MyPhotoIndex.Plugins
{
    public class FlickrPluginSettings : IDynamicSetting
    {
        private static ISettingsManager m_settingsManager;

        private bool m_isPublic;
        private bool m_isFamily;
        private bool m_isFriend;

        public FlickrPluginSettings()
        {

        }

        public override string ToString()
        {
            return "Flickr Plugin";
        }

        public static FlickrPluginSettings Default
        {
            get
            {
                return (FlickrPluginSettings)SettingsManager[typeof(FlickrPluginSettings)];
            }
        }

        public static ISettingsManager SettingsManager
        {
            get { return FlickrPluginSettings.m_settingsManager; }
            set { FlickrPluginSettings.m_settingsManager = value; }
        }

        [Category("Flickr Plugin")]
        [DisplayName("Upload Images as public images")]
        public bool IsPublic
        {
            get { return m_isPublic; }
            set { m_isPublic = value; }
        }

        [Category("Flickr Plugin")]
        [DisplayName("Upload Images as Family images")]
        public bool IsFamily
        {
            get { return m_isFamily; }
            set { m_isFamily = value; }
        }

        [Category("Flickr Plugin")]
        [DisplayName("Upload Images as Friend images")]
        public bool IsFriend
        {
            get { return m_isFriend; }
            set { m_isFriend = value; }
        }

        internal void Save()
        {
            SettingsManager.Save();
        }
    }
}
