/*MyPhotoIndex Free Photo Organizer <www.myphotoindex.com>
  Copyright (C) <2006-2007>  <Asaf Yarkoni asaf@yarkoni.net>

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
using System;
using System.Collections.Generic;
using System.Text;
using System.ComponentModel;
using MyPhotoIndex.Interfaces;

namespace MyPhotoIndex.Plugins
{
    public class Pic4uPluginSettings : IDynamicSetting
    {
        private static ISettingsManager m_settingsManager;

        private bool m_isPublic;
        private bool m_isFamily;
        private bool m_isFriend;
        private string m_savedUserName;

        public Pic4uPluginSettings()
        {

        }

        public override string ToString()
        {
            return "Pic4u.co.il Plugin";
        }

        public static Pic4uPluginSettings Default
        {
            get
            {
                return (Pic4uPluginSettings)SettingsManager[typeof(Pic4uPluginSettings)];
            }
        }

        public static ISettingsManager SettingsManager
        {
            get { return Pic4uPluginSettings.m_settingsManager; }
            set { Pic4uPluginSettings.m_settingsManager = value; }
        }

        [Category("Pic4u Plugin")]
        [DisplayName("Upload Images as public images")]
        public bool IsPublic
        {
            get { return m_isPublic; }
            set { m_isPublic = value; }
        }

        [Category("Pic4u Plugin")]
        [DisplayName("Upload Images as Family images")]
        public bool IsFamily
        {
            get { return m_isFamily; }
            set { m_isFamily = value; }
        }

        [Category("Pic4u Plugin")]
        [DisplayName("Upload Images as Friend images")]
        public bool IsFriend
        {
            get { return m_isFriend; }
            set { m_isFriend = value; }
        }

        [Category("Pic4u Plugin")]
        [DisplayName("Last User name used")]
        [Browsable(false)]
        public string SavedUserName
        {
            get { return m_savedUserName; }
            set { m_savedUserName = value; }
        }

        internal void Save()
        {
            SettingsManager.Save();
        }
    }
}
